#!/bin/sh 

base_app_name=`/bin/basename $0`
usage()
{
    echo ""
    echo "Use this utility to change Secondary machine post primary upgrade"
    echo "This sutility shoud be run on Primary machine prior to Secondary upgrade."
    echo ""
    echo "Usage: "
    echo "$base_app_name -name <name> -ipAddress4 <IPv4> "
    echo ""
    echo "required parameters:"
    echo ""
    echo "'-name <name>'          Network Object name of Secondary machine"
    echo "'-ipAddress4 <IPv4>'    New IP for Secondary machine"
    echo ""
    echo "Options (optional parameters):"
    echo ""
    echo "'-h'                    Show this message."    
    echo ""
    echo ""
}

parse_args()
{
    while [ $# -gt 0 ]
    do
        case $1 in
            -name)
                shift
                if [ $# -eq 0 ]; then				   
                    usage
                    exit 1
                fi
                objName=$1
            ;;
            -ipAddress4)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                newIpAddress4=$1
            ;;   
            -h)
                help=1
                usage
                exit 0
            ;;				
        *)
            usage
            exit 1

        esac
        shift
    done
}

validate_args()
{
	if [ "X$objName" = "X" ];then
		echo "Missing parameters"
		usage
		exit 1
	fi
	
	if [ "X$newIpAddress4" = "X" ];then
		echo "Missing parameters"
		usage
		exit 1
	fi
	
	isMDS=`$CPDIR/bin/cpprod_util CPPROD_GetValue PROVIDER-1 LoginServer 1`
	if [ "X1" = "X$isMDS" ]; then 
		isPrimary=`$CPDIR/bin/cpprod_util CPPROD_GetValue PROVIDER-1 Primary 1`		
	else
		isPrimary=`$CPDIR/bin/cpprod_util FwIsPrimary`
	fi 
	if [ "X0" = "X$isPrimary" ]; then
		echo "This is not a Primary machine"
		usage
		exit 1
	fi
	
	if [[ $newIpAddress4 =~ ^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
		echo
	else
		echo "Illegal Server IP address $newIpAddress4"
		exit 1
	fi
}

parse_args $@
validate_args
objId=$(psql_client cpm postgres -t -c "select objid from cpnetworkobject_data where dlesession=0 and not deleted and name='$objName';")
if [ "X$objId" = "X" ];then
	echo "Failed to find cp network object with name $objName"
	exit 1
fi
mgmt_cli -r true set generic-object uid $objId ipAddress4 $newIpAddress4