#!/bin/sh
. /opt/CPshared/5.0/tmp/.CPprofile.sh >> /dev/null

set_vars()
{
    base_app_name=`/bin/basename $0`
    uniq_ext=`/bin/date '+%e%b%Y-%H%M%S' | /bin/sed 's/ //g'`
    mode="none"
    nonlocal=0
    migrate_args=""
    revision=""
    version=""
    async=0
    minimal_setup=0
    postinstall=0
    jars_changed=0
    server_ip="127.0.0.1"
    outputfile=""
    outputdir=""
    tarfile=""
    log_file="$MDS_FWDIR/log/upgrade_log.${uniq_ext}.elg"
    client_log="$MDS_FWDIR/log/upgrade_client.elg"
    server_log="$MDS_FWDIR/log/cpm.elg"
    debug_logs_location_file="/var/log/debug_logs_location_file.txt"
    print_progress_for_state_pid=-1
    poll_task_pid=-1
    operation_finished_description="Done"
    REPORT_LOG_PATH="$MDS_FWDIR/log/upgrade_report/upgrade_report.html"
    operation_start_time=""
    report_path=""
    percents=0
    mu_succeeded_file="$MDS_FWDIR/tmp/mu_succeeded"
    mu_failed_file="$MDS_FWDIR/tmp/mu_failed"
    verify_failed_file="$MDS_FWDIR/tmp/import_verify_failed"
    verify_succeeded_file="$MDS_FWDIR/tmp/import_verify_succeeded"
    additional_json_args=""
    help=0
    mask_info=0
    upgrade_tools_prefix=/opt/CPupgrade-tools
    non_interactive=0
    exit_code=0
    verify_result=0
    collect_debug_logs=1
    TAR=/usr/bin/tar
    validations=0
    domain_name=""
    server_name=""
    domain_server_ip=""
    should_run_apecial_mu=0
    cma_name=""
    cma_id=""
    post_import_failure=0
    post_install_after_failure_file="$MDS_FWDIR/tmp/post_install_after_import_failure"
    show_progress_bar=1
    force_upgrade_flow=1
	  old_migrate_path=""
	  is_old_migrate=1
    ignore_warnings=0
    keep_cloud_sharing=0
    skip_uepm_activation=0
    smart_1_cloud=0
    verify_all_servers=0
    verify_local_only=0
    skip_tools_check_on_remote=0
    taskid=""
    interrupted_task_comment="Task was interrupted because of server restart"
    should_collect_logs=0
    log4j2_conf_file="$MDS_FWDIR/conf/log4j2.xml"
    clm_logs=0
    clm_name=""
    should_create_migration_failed_files=0
    task_found_flag=0
    upgrade_or_migration="upgrade"
    UpgradeOrMigration="Upgrade"
    verify_restart_version=0
    verify_new_version=0

    MDS=`$CPDIR/bin/cpprod_util CPPROD_GetValue PROVIDER-1 ProdActive 1`
    if [ $? -eq 0 ]; then
    # rpm of MDS installed - this is MDS ENV
    # MDSDIR is not defined - still in FTW - ask the user either to relogin or wait till FTW will be completed
     if [ $MDS -eq 1  -a "X$MDSDIR" = "X" ]; then
        echo  "This is a Multi-Domain environment and MDSDIR is not defined yet. Please open a new ssh session and try again." | tee -a $log_file
        exit 1
     fi
    fi

	restart_cpm_server=0
	
    if [ "X$MDSDIR" = "X" ]; then
        CPM_DIR=$FWDIR/cpm-server
        start_cmd=cpstart
        stop_cmd="cpstop; cpwd_admin kill"
        postgres_start="$MDS_FWDIR/scripts/postgres_start.sh"
        cpm_mu_cmd="$MDS_FWDIR/scripts/cpm.sh -s -d -mu -e"
        cpm_cmd="$MDS_FWDIR/scripts/cpm.sh -s -d -e"
        cpm_start_cmd="cpshared start; $MDS_FWDIR/scripts/ngm_start.sh"
        start_cmd_export=cpstart
        stop_fwm_command="cpwd_admin stop -name FWM -path \"$FWDIR/bin/fw\" -command \"fw kill fwm\""
        MIGRATION_HAD_FAILED_FILE="$FWDIR/migration_had_failed"
    else
        CPM_DIR=$MDS_TEMPLATE/cpm-server
        start_cmd="(. $MDS_CPDIR//tmp/.CPprofile.sh; mdsstart)"
        stop_cmd=mdsstop
        postgres_start="FWDIR=$MDS_TEMPLATE $MDS_FWDIR/scripts/postgres_start.sh"
        cpm_mu_cmd="FWDIR=$MDS_TEMPLATE $MDS_FWDIR/scripts/cpm.sh -s -d -mu -e"
        cpm_cmd="FWDIR=$MDS_TEMPLATE $MDS_FWDIR/scripts/cpm.sh -s -d -e"
        cpm_start_cmd="mdsstart -cpm"
        start_cmd_export=mdsstart
        stop_fwm_command="mdsstop -m"
        MIGRATION_HAD_FAILED_FILE="$MDSDIR/migration_had_failed"
        MIGRATION_IN_PROGRESS_FILE="$MDS_TEMPLATE/migration_in_progress"
    fi
    ARGS=""
    API_ARGS=""
    export_restart_cmds=(is_valid_export run_slim_verify_service is_equal_versions get_stop_permission start_server run_service restart_server)
    export_cmds=(is_valid_export run_slim_verify_service is_equal_versions start_server run_service)
    import_cmds=(run_slim_verify_service remove_migration_had_failed_file is_equal_versions start_server stop_fwm check_postgres_is_up run_service)
    migrate_import_domain_cmds=(run_slim_verify_service start_server run_service)
    configure_smc_backup_cmds=(start_server run_service)
    verify_restart_cmds=(run_verify_service)
    verify_cmds=(run_slim_verify_service start_server run_service)
    major_upgrade_setup_cmds=(disable_progress_bar unset_upgrate_tools_path run_mininal_postinstall)
    phases=("start_server" "start_import_service")
    check_is_mlm
    check_is_log_server
    check_is_smc_backup
    check_is_primary
    check_machine_type
    check_previous_upgrade_had_failed
    find_ssl_port
    ver=$(find_current_version)
    server_restart_versions=("R80.20" "R80.20.M1" "R80.20.M2" "R80.30" "R80.40")
    if [[ "${server_restart_versions[@]}" =~ "${ver}" ]]; then
        restart_cpm_server=1	
    fi
}

#usage
usage()
{
    echo ""
    echo "Use the migrate utility to : 1. Verify, export and import the Check Point"
    echo "                                Security Management Server database."
    echo "                             2. Migrate_import_domain"
    echo "    1. Verify, export and import "
    echo ""
    echo "         Usage: migrate_server <ACTION> <PARAMETERS> [OPTIONS] <FILE>"
    echo ""
    echo "         ACTION (required parameter):"
    echo ""
    echo "         export - exports database of Management Server/ Multi Domain Server."
    echo "         import - imports database of Management Server/ Multi Domain Server."
    echo "         verify - verifies database of Management Server/ Multi Domain Server."
    echo ""
    echo "         Options (optional parameters):"
    echo ""
    echo "         '-h'                           Show this message."
    echo "         '-ma <args>'                   Migrate args. Example: -ma l+d+i"
    echo "         '-revision <all|last>'         Export all the revisions or only last revision"
    echo "         '-v <target version>'          Version of target release ie. M1, M2, etc."
    echo "         '-d <output directory>'   	Output directory (no archiving is performed)"
    echo "         '-non-interactive'             Run non-interactively"
    echo "         '-n,--nonlocal'                export only Non Local domains."
    echo "                                        Default to export entire system."
    echo "                                        Note: option is valid for export mode only."
    echo "         '-i <server IP address>'       IP address of Management Server"
    echo "                                        Default is local machine."
    echo "         '-mu'                          run minimal setup postinstall"
    echo "                                        Note: valid for import mode only"
    echo "         '-do_not_collect_logs'         Do not collect debug logs at the end of requested action. Default is to collect debug logs"
    echo "                                        Note: relevant for export & import only. The log files are archived and put in /var/log/ directory."
    echo "         -a,--async                     do not wait will the end of task and print task Id"
    echo "         '-o <path to output file>'     Path to output file"
    echo "                                        By default output file is generated in current working directory."
    echo "                                        Note: option is valid for export mode only."
    echo "         '-fp,--first_phase <phase>'    Run migration in phases. Start from phase defined by <phase> argument."
    echo "                                        Note: If the phase is not defined migration starts from the beginning."
    echo "                                        Note: option is valid for import mode only."
    echo "         '-lp,--last_phase <phase>'     Run migration in phases. Finish at phase defined by <phase> argument."
    echo "                                        Note: If the phase is not defined migration runs till last migrate phase w/o interruptions"
    echo "                                        Note: option is valid for import mode only."
    echo "         '-npb,--no_progress_bar'       Disable the progress bar."
    echo "         '-force-upgrade-flow'          When the source and target servers are on the same major version, migrate_server uses an accelerated flow to migrate the data."
    echo "                                        This flag forces the full migration flow."
    echo "                                        Note: if this flag is used, it is mandatory to use it both on export and import."
    echo "         '-ivw,--ignore_warnings'       Perform Export/Import although the pre-verification process raised warnings."
    echo "                                        Note: option is valid for import and export modes only."
    echo "         '--keep_cloud_sharing'         Preserve the connection of the Management Server to Check Point's Infinity Portal."
    echo "                                        Use this flag after ensuring that the original Management Server does not communicate with Infinity Portal."
    echo "                                        Note: resuming the connection is also possible after import with set-cloud-services."
    echo "                                        Note: option is valid for import mode only."
    echo "         '--clm_logs < Domain Log Server name>'        Perform migration of a given Domain Log Server including logs and indexes."
    echo "                                        Note: Domain Log Server name in the source and target should be different."
    echo "         '--verify_all_servers'         Runs the verification process on all Management Servers and Log Servers."
    echo "                                        Notes:"
    echo "                                           1) This flag is valid only for the 'verify' and 'export' operations."
    echo "                                           2) This flag is supported on the versions R81 and higher."
    echo "                                           3) List of servers, on which you can run the 'migrate_server verify' / 'migrate_server export'"
    echo "                                              command with the flag '--verify_all_servers':"
    echo "                                              - All Security Management Servers"
    echo "                                              - Multi-Domain Security Management Servers"
    echo "                                              - Multi-Domain Log Servers"
    echo "                                           4) List of remote servers, to which the 'migrate_server verify' / 'migrate_server export' command can connect:"
    echo "                                              - Security Management Servers"
    echo "                                              - Multi-Domain Security Management Servers"
    echo "                                              - Multi-Domain Log Servers"
    echo "                                              - Dedicated Log Servers"
    echo "                                              - Dedicated SmartEvent Servers"
    echo "                                              - Security Management Servers configured as a Backup of a Domain Management Server"
    echo "                                              Note:"
    echo "                                              Servers that are configured on a specific Domain on a Multi-Domain Security Management Server will be verified"
    echo "                                              only if there is a Domain Server of that Domain on the current Multi-Domain Security Management Server."
    echo "                                           5) The default behavior:"
    echo "                                              - Only on Primary Management Servers, the 'migrate_server verify' command runs with the '--verify_all_servers' flag."
    echo "                                              - On all servers except Primary Management Servers, the 'migrate_server verify' command runs with the '--verify_local_only' flag."
    echo "                                              - On all servers without exception, the 'migrate_server export' command runs with the '--verify_local_only' flag."
    echo "         '--verify_local_only'          Runs the verification process locally, only on the current server."
    echo "                                        Notes:"
    echo "                                           1) This flag is valid only for the 'verify' and 'export' operations."
    echo "                                           2) The default behavior:"
    echo "                                              - On all servers except Primary Management Servers, the 'migrate_server verify' command runs with the '--verify_local_only' flag."
    echo "                                              - On all servers without exception, the 'migrate_server export' command runs with the '--verify_local_only' flag."
    echo "         '-skip_tools_check_on_remote'  Specifies not to check for updated Upgrade Tools when running the verification process on other remote Management Servers (not the current Management Server)."
    echo "                                        Notes:"
    echo "                                           1) This flag is valid only for the 'verify' and 'export' operations."
    echo "                                           2) This flag is valid only when running the verification process on all Management Servers (not only on current server)."

    echo ""
    echo "         File (required parameter only for import):       Name of archived file to import."
    echo ""
    echo ""
    echo "    2. Migrate_import_domain "
    echo "          usage: migrate_server <ACTION>  [OPTIONS]"
    echo ""
    echo "          ACTION (required parameter):"
    echo ""
    echo "          migrate_import_domain - Imports the database of the Domain Management Server"
    echo "                                  from a Multi-Domain Server."
    echo ""
    echo "          Options (optional parameters):"
    echo ""
    #echo "'-dn <Domain name>'      Name of the domain which will be created on the MDS Server"
    #echo ""
    echo ""
    echo "          '-sn <Domain Server name>'           Name of the Domain Management Server"
    echo ""
    echo "          '-dsi <Domain Server IP address>'    IP address of the Management Server"
    echo "                                               Default is local machine."
    echo "          '-skip_logs'                         Skip import logs (without log indexes.)"
    echo "         '--keep_cloud_sharing'                Preserve the connection of the Management Server to Check Point's Infinity Porta."
    echo "                                               Use this flag after ensuring that the original Management Server does not communicate with Infinity Portal."
    echo "                                               Note: resuming the connection is also possible after import with set-cloud-services."

    echo ""
    echo "          '-o <path to export file>'           Path to export file."

    if [ $help -eq 1 ]; then
        echo "TroubleShooting OPTIONS"
        echo "-----------------------"
        echo "Import phases by timeline:                        "
        echo "0 - Perfrom minimal setup postinstall."
        echo "1 - Start server in upgrade mode  following minimal setup postinstall."
        echo "2 - Start import service."
        echo "3 - Restart cpm server in regular ( non upgrade ) mode."
        echo ""
        echo "Example: "
        echo "Run import minimal postinstall setup only and exit"
        echo "  $base_app_name import -lp 0 export.tgz"
        echo "Run import following minimal postinstall and complete import process"
        echo "  $base_app_name import export.tgz"
        echo "OR"
        echo "  $base_app_name import -fp 1 export.tgz"
        echo "Run import from minimal postinstall setup and just start server and upgrade mode"
        echo "  $base_app_name import -lp 1  export.tgz"
    fi

}


signal_2()
{
  stop_output_update 1
	echo "Got signal INTERRUPT, exiting"
	print_and_exit "Got signal INTERRUPT, exiting" 2
}

signal_3()
{
  stop_output_update 1
	echo "Got signal QUIT, exiting"
    print_and_exit "Got signal QUIT, exiting" 3
}

signal_9()
{
  stop_output_update 1
	echo "Got signal KILL, exiting"
    print_and_exit "Got signal KILL, exiting" 9
}

signal_15()
{
  stop_output_update 1
	echo "Got signal TERM, exiting"
    print_and_exit "Got signal TERM, exiting" 15
}

#parse args
parse_args()
{
    while [ $# -gt 0 ]; do
        case $1 in
            export)
                mode="export"
                ;;
            import)
                mode="import"
                ;;
            verify)
                mode="verify"
                ;;
            migrate_import_domain)
                mode="migrate_import_domain"
                should_run_apecial_mu=1
                ;;
            configure_smc_backup)
                mode="configure_smc_backup"
                should_run_apecial_mu=1
                ;;
            -h)
                help=1
                usage
                exit 0
                ;;
            -n|--nonlocal)
                nonlocal=1
                ;;
            -d|--directory)
                if [ $# -ne 1 ]; then
                    shift
                    outputdir=$1
                fi
                ;;
            -mask)
                mask_info=1
                ;;
            -ma)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                migrate_args="$migrate_args$1"
                ;;
            --exclude-licenses)
                if [ "X$mode" != "Ximport" ]; then
                    echo "Option '--exclude-licenses' can be used only with 'import' action"
                    exit 1
                fi                      
                add_migrate_arg $1
                ;;
            --skip_uepm_activation)
                if [ "X$mode" != "Ximport" ]; then
                    echo "Option '--skip_uepm_activation' can be used only with 'import' action"
                    exit 1
                fi 
                add_migrate_arg $1
                skip_uepm_activation=1
                ;;
            -cma_name)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                cma_name=$1
                ;;
            -cma_id)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                cma_id=$1
                ;;
            -revision)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                revision=$1
                ;;
             -change_ips_file)
                echo "The flag '-change_ips_file' is obsolete. Create the required file /var/log/mdss.json with the new IP address(es) and run the import again."
                exit 1
                ;;
            -i)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                server_ip=$1
                ;;
            -a|--async)
                async=1
                ;;
            -fp|--first_phase)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                first_phase=$1
                ;;
            -lp|--last_phase)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                last_phase=$1
                ;;

            -o)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                outputfile=$1
                tarfile=$1
                ;;
            -mu)
                minimal_setup=1
                first_phase=0
                ;;
            -pi)
                postinstall=1
                ;;
            -v)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                version=$1
                ;;
            -non-interactive)
                non_interactive=1
                ;;
            --keep_cloud_sharing)
                keep_cloud_sharing=1
                ;;
            --smart_1_cloud)
                smart_1_cloud=1;
                add_migrate_arg $1
                ;;
            --verify_all_servers)
                if [ $restart_cpm_server -eq 1 ]; then
                    echo "The flag '--verify_all_servers' is supported for the versions R81 and higher."
                    exit 1
                fi

                if [ $LOG_SERVER -eq 1 ]; then
                    echo "The flag '--verify_all_servers' is not supported for Log Servers and SmartEvent Servers."
                    exit 1
                fi
                
                if [ $SMC_BACKUP -eq 1 ]; then
                    echo "The flag '--verify_all_servers' is not supported for Security Management Servers configured as a Backup of a Domain Management Server."
                    exit 1
                fi
                
                if [ "X$mode" != "Xexport" -a "X$mode" != "Xverify" ]; then
                    echo "The flag '--verify_all_servers' is valid only for the 'verify' and 'export' operations."
                    exit 1
                fi

                verify_all_servers=1;
                ;;
            --verify_local_only)
                if [ "X$mode" != "Xexport" -a "X$mode" != "Xverify" ]; then
                    echo "The flag '--verify_local_only' is valid only for the 'verify' and 'export' operations."
                    exit 1
                fi
                verify_local_only=1;
                ;;
            -skip_tools_check_on_remote)
                if [ "X$mode" != "Xexport" -a "X$mode" != "Xverify" ]; then
                    echo "The flag '-skip_tools_check_on_remote' is valid only for the 'verify' and 'export' operations."
                    exit 1
                fi
                skip_tools_check_on_remote=1;
                ;;
            -do_not_collect_logs)
                collect_debug_logs=0
                ;;

            -dn|--domain_name)
                shift
                if [ $# -eq 0 ]; then
                    exit 1
                fi
                domain_name=$1
                ;;
            -sn|--server_name)
                shift
                if [ $# -eq 0 ]; then
                    exit 1
                fi
                server_name=$1
                ;;
            -dsi|--domain_server_ip)
                shift
                if [ $# -eq 0 ]; then
                    exit 1
                fi
                domain_server_ip=$1
                ;;
            --validations-only)
                shift
                validations=1
                ;;
            -pif|--post_import_failure)
                post_import_failure=1
                ;;
            -npb|--no_progress_bar)
                show_progress_bar=0
                ;;
            -force-upgrade-flow)
                force_upgrade_flow=0
                ;;
            -ivw|--ignore_warnings)
            if [ "X$mode" != "Xexport" -a "X$mode" != "Ximport" -a "X$UPGRADE_CONTEXT" != "Xcpuse" ]; then
                echo "The flag '--ignore_warnings' is valid only for the 'import' and 'export' operations."
                    exit 1
                else
                    ignore_warnings=1;
                fi
                ;;
            --clm_logs)
                shift
                if [ $# -eq 0 ]; then
                    usage
                    exit 1
                fi
                clm_name=$1
                clm_logs=1
                ;;
            *)
                if [ "X$tarfile" == "X" ]; then
                    tarfile=$1
                else
                    usage
                    exit 1
                fi
        esac

        shift
    done

    #When running verifications on the primary server in R81 and above- run it on all servers by default.
    if [ $IS_PRIMARY -eq 1 -a $verify_local_only -eq 0 -a "X$mode" = "Xverify" -a $restart_cpm_server -eq 0 -a $smart_1_cloud -eq 0 -a "X$UPGRADE_CONTEXT" != "Xcpuse" ]; then
        verify_all_servers=1
    fi

    if [ "X$minimal_setup" = "X1" ]; then
        mode="setup"
    fi

    if [ "X$mode" = "Xexport" -a "X$outputfile" = "X" -a "X$tarfile" != "X" ]; then
        outputfile=$tarfile
    fi

    if [ "X$mode" = "Xexport" -a "X$outputfile" = "X" -a "X$outputdir" = "X" ]; then
        outputfile=`pwd`/export.${uniq_ext}.tgz
    fi

    phase_file=${CPM_DIR}/${mode}_phase.conf
    set_phase_args
    if [ $mode = "verify" ]; then
        collect_debug_logs=0;
    fi

    debug_logs_location="/var/log/upgrade-$mode.${uniq_ext}.tgz"
    if [ "$mode" == "export" ] || [ "$mode" == "import" ]; then
        echo $debug_logs_location > $debug_logs_location_file
        echo "created debug_logs_location_file" >> $log_file
    fi

    #import ,migrate_import_domain or configure_smc_backup mode but no version was defined
    if [ "X$mode" = "Ximport" -o "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Xconfigure_smc_backup" ]; then
        if [ "X$version" = "X" ]; then
            version=$ver
        fi
    fi
}

set_java_options_for_client()
{
	NGM_JAVA_OPTS=""
	JAVA_TMP_DIR=$MDS_FWDIR/tmp
	if [ "X$CPM_REMOTE_DEBUG" = "X1" ]; then
		NGM_JAVA_OPTS="$NGM_JAVA_OPTS -Xdebug -Xrunjdwp:server=y,transport=dt_socket,address=5005,suspend=n"
	fi

	NGM_JAVA_OPTS="$NGM_JAVA_OPTS -Djava.io.tmpdir=$JAVA_TMP_DIR"
}

set_phase_args()
{
    if [ "X$mode" != "Ximport" ]; then
        return
    fi
    performed_phase=0
    if [ -f $phase_file ]; then
        performed_phase=`cat $phase_file`
        ((++performed_phase))
    fi

    #if first phase is not defined set as already performed phase
    #otherwise check if it at least performed phase
    if [ ! -z "$first_phase" ]; then
           if [ $performed_phase -lt $first_phase ]; then
                echo "WARNING: Fisrt phase is ${phases[$first_phase]}, while machine have not undergone ${phases[$performed_phase]}. Overriding first_phase with ${phases[0]}"
                first_phase=$performed_phase
           fi
    else
        first_phase=$performed_phase
    fi

    if [  -z "$last_phase" ]; then
        last_phase=$((${#import_cmds[@]}-1))
    fi

    if [ $performed_phase -gt $last_phase -a $first_phase -ne 0 ]; then
        echo "WARNING: Last phase is ${phases[$last_phase]}, while machine have already undergone ${phases[$((performed_phase - 1))]}. Starting from minimal setup."
        first_phase=0
    fi
    if [ $first_phase -eq 0 ]; then
        minimal_setup=1
    fi

}

validate_phase_args()
{
    if [ "X$mode" != "Ximport" ]; then
        return 0
    fi
    if [ $first_phase -gt $last_phase ]; then
        echo "Error: first phase is greater then last phase , exiting"
        return 1
    fi
}

validate_args()
{
    if [ "X$mode" = "Xnone" ]; then
       usage
       return 1
    fi

    if [ "X$mode" = "Ximport" ];then
        if [ "X$tarfile" = "X" -a -z "$outputdir" ]; then
            usage
            return 1
        fi

        if [ "X$tarfile" != "X" ]; then
			if [ ! -e $tarfile ];then
				echo "Tar file: $tarfile doesn't exist."
				return 1
			fi
			first_char=`echo $tarfile | cut -c1,1`
			if [ ${first_char:-xxx} != "/" ]; then
				echo "$tarfile file must have absolute path, aborting."
				return 1
			fi
		fi

        check_old_migrate
		check_migration_type
		check_primary_upgrade

    fi

    if [ "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Xconfigure_smc_backup" ];then
      if [ "X$tarfile" = "X" ];then
        usage
        exit 1
      fi

      if [ ! -e $tarfile ];then
        echo "Tar file: $tarfile doesn't exist."
        exit 1
     fi

      # test if full path was supplied
      if [[ "${tarfile:0:1}" != "/"  ]];then
        echo "Please provide full path to export file" | tee -a $log_file
        exit 1
      fi

      extension=${tarfile: -4}
      if [[ "$extension" != '.tgz' ]]; then
        echo "Please provide .tgz export file" | tee -a $log_file
        exit 1
      fi

      if [ "X$mode" = "Xmigrate_import_domain" ];then
        check_old_migrate
        check_migration_type
      fi
    fi



	if [[ $server_ip =~ ^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
		echo > /dev/null
	else
		echo "Illegal Server IP address $server_ip"
		return 1
	fi

	if [ "X$outputfile" != "X" -a "X$mode" = "Xexport" ]; then
		if [ -d $outputfile ]; then
			echo "$outputfile: should be file, aborting."
			return 1
		fi
        first_char=`echo $outputfile | cut -c1,1`
        if [ ${first_char:-xxx} != "/" ]; then
            echo "$tarfile file must have absolute path, aborting."
            return 1
        fi
        basedir=$(dirname "$outputfile")
        if [ ! -w $basedir ]; then
            echo "$outputfile: has no write permission."
            return 1
        elif [ -e $outputfile -a ! -w $outputfile ]; then
            echo "$outputfile: has no write permission."
            return 1
        fi
	fi

    if [ ! -z "$outputdir" -a "X$mode" = "Ximport" ]; then
        if [ ! -e $outputdir ];then
            echo "directory: $outputdir doesn't exist."
            return 1
        fi
        first_char=`echo $outputdir | cut -c1,1`
        if [ ${first_char:-xxx} != "/" ]; then
            echo "$outputdir directory must have absolute path, aborting."
            return 1
        fi
    fi


    if [ "X$mode" = "Ximport" ]; then
        if [  $first_phase -gt $last_phase ]; then
            echo "Illegal import phase definition."
            echo "Start import phase: $first_phase is greater than the last import phase: $last_phase"
            return 1
        fi
    fi

  if [ $verify_all_servers -eq 1 -a $verify_local_only -eq 1 ]; then
      echo "Ambiguous request. You provided both '--verify_local_only' and '--verify_all_servers' flags."
      exit 1
  fi

  if [ $verify_all_servers -eq 0 -a $skip_tools_check_on_remote -eq 1 ]; then
    if [ $verify_local_only -eq 1 ]; then
      echo "The flag '-skip_tools_check_on_remote' is not valid with the flag '--verify_local_only'." #On primary migrate_server verify
    else
      echo "Ambiguous request. You provided the '-skip_tools_check_on_remote' flag, but did not provide the '--verify_all_servers' flag." #On non primary or migrate_server export
    fi
    exit 1
  fi

  validate_migrate_args

	return 0

}

check_current_status()
{
    if [ -e $NGM_UPGRADE_TOOLS_PATH/scripts/current_status.sh ]; then
      echo "Running 'current_status.sh'" >> $log_file
      $(timeout 300 $NGM_UPGRADE_TOOLS_PATH/scripts/current_status.sh -lf $log_file) >> $log_file 2>&1
      ret_stat=$?
      echo "ret_stat: $ret_stat" >> $log_file
    else
      echo "The script '$NGM_UPGRADE_TOOLS_PATH/scripts/current_status.sh' wasn't found" >> $log_file
    fi
}

check_is_mlm()
{
    IS_MLM=0
    if [ "X$MDSDIR" != "X" ]; then
        isMDS=`$CPDIR/bin/cpprod_util CPPROD_GetValue PROVIDER-1 LoginServer 1`
        if [ "X0" = "X$isMDS" ]; then
            IS_MLM=1
        fi
    fi
}

check_is_log_server()
{
	LOG_SERVER=0
    if [ "X$MDSDIR" = "X" ]; then
        isLogServer=`$CPDIR/bin/cpprod_util FwIsLogServer| /bin/sed 's/ //g'`
        if [ "X1" = "X$isLogServer" ]; then
            LOG_SERVER=1
        fi
    fi

}

check_is_smc_backup()
{
	SMC_BACKUP=0
  isSmcBackup=`$CPDIR/bin/cpprod_util CPPROD_GetValue FW1 SMCBackup 1 | /bin/sed 's/ //g'`
  if [ "X1" = "X$isSmcBackup" ]; then
      SMC_BACKUP=1
  fi
}

check_is_primary()
{
	IS_PRIMARY=0
    isPrimary=`$CPDIR/bin/cpprod_util FwIsPrimary| /bin/sed 's/ //g'`;
    if [ "X1" = "X$isPrimary" ]; then
        IS_PRIMARY=1
    fi
}

check_machine_type()
{
  machine_type="primary machine"
  if [ $IS_MLM -eq 1 ]; then
      machine_type="multi domain log server"
  elif [ $LOG_SERVER -eq 1 ]; then
      machine_type="log server"
  elif [ $IS_PRIMARY -eq 1 ]; then
      machine_type="primary machine"
  else
      machine_type="secondary machine"
  fi
}

find_ssl_port()
{
  portNumber=`clish -c 'show web ssl-port' | grep -v lock | awk '{print $NF}' `
  if [ $? -ne 0 ]; then
    echo "Failed to retrieve ssl port. using default- 443"  >> $log_file 2>&1
    portNumber=443
  fi
}

check_fwm_connected()
{
	command_file=/tmp/cmd.${uniq_ext}.txt
	echo "quit" > $command_file
	trials=1
	ret=1
    if [ $IS_MLM -eq 1 ]; then
        return $ret
    fi

	while [ $trials != 240 ]
	do
          if [[ "${server_restart_versions[@]}" =~ "${ver}" ]]; then
            dbedit -readonly -local -f $command_file >> $log_file 2>&1
          else
            if [ "$(api status -f json | jq -r .api.is_ready)" == "true" ]; then
              mgmt_cli -r true --port $portNumber login > $command_file 2>&1
              mgmt_cli -r true --port $portNumber logout -s $command_file >> $log_file 2>&1
            else
            	dbedit -readonly -local -f $command_file >> $log_file 2>&1
            fi

          fi

        if [ $? -eq 0 ]; then
          ret=0
          break;
        else
          echo "The management server is not up yet, trials count: $trials out of 240" >> $log_file
        fi
		((trials++))
		sleep 30
	done
	if [ $ret -eq 1 ]; then
	    print_and_exit "Fwm is not up yet." 1
	fi
	return $ret
}

prepare_jars()
{
 # can add upgrade_tools.tgz unpack
#move dle_test_objects.jar if exist
 if [ -e $CPM_DIR/dleserver_integration_tests.jar ]; then
    mv -f $CPM_DIR/dleserver_integration_tests.jar $CPM_DIR/dleserver_integration_tests.jar.DONOT_REMOVE
	jars_changed=1
 fi

 if [ -e $CPM_DIR/dle_test_objects.jar ]; then
    mv -f $CPM_DIR/dle_test_objects.jar $CPM_DIR/dle_test_objects.jar.DONOT_REMOVE
	jars_changed=1
 fi
}

revert_jars()
{
 if [ -e $CPM_DIR/dleserver_integration_tests.jar.DONOT_REMOVE ]; then
    mv -f $CPM_DIR/dleserver_integration_tests.jar.DONOT_REMOVE $CPM_DIR/dleserver_integration_tests
 fi

 if [ -e $CPM_DIR/dle_test_objects.jar.DONOT_REMOVE ]; then
    mv -f $CPM_DIR/dle_test_objects.jar.DONOT_REMOVE $CPM_DIR/dle_test_objects.jar
 fi

}


call_check_cpm()
{
  $MDS_FWDIR/scripts/check_cpm_status.sh no_print
  exitCode=$?
  duration=$SECONDS
  if [ $exitCode -ne 1 ]; then
     echo "$(date) : Exit code of check_cpm_status is : $exitCode after $duration seconds" >> $log_file 2>&1
  fi
}

check_cpm_status()
{
  SECONDS=0
  duration=$SECONDS
  exitCode=255
  failure_number=$1
  timeout=$2
  create_files=$3

  while [ $duration -lt 600 ] && [ $exitCode -ne 0 ] && [ $exitCode -ne 1 ]; # Give the server $timeout seconds to initialize
   do
        call_check_cpm
   done
  while [ $duration -lt $timeout ] && [ $exitCode -eq 0 ]; # Give the server $timeout seconds to initialize
    do
        call_check_cpm
    done

  if [ $exitCode -ne 1 ]; then
    should_collect_logs=1
    should_create_migration_failed_files=$create_files
    print_and_exit "Failed to connect to server. Exiting $failure_number " $failure_number
  fi
}

verify_cpm_is_down()
{
    total_trials=60
    try_turn_off_again_after=30
    trials=0
    sleep_time=30
    while [ $total_trials -gt $trials ] ;
    do
      CPM_STATUS=`$MDS_FWDIR/scripts/cpm_status.sh`
      stat_code=$?
      if [ $stat_code -eq 13 ]; then
          echo "$(date): exit code: ${stat_code}, status: ${CPM_STATUS}" >> $log_file 2>&1
          return 1
      fi
      (( trials++ ))
      echo "cpm is not down yet, exit code: ${stat_code}, status: ${CPM_STATUS} - going to sleep for ${sleep_time} seconds ($trials/$total_trials)" >> $log_file 2>&1
      if [ $try_turn_off_again_after -eq $trials ] ; then
          echo "$(date): Trying to turn off the cpm again:" >> $log_file 2>&1
          eval $stop_cmd >> $log_file 2>&1
      fi
      if [ $total_trials -gt $trials ] ; then
          sleep $sleep_time
      fi
    done
	echo "$(date): exit code: ${stat_code}, status: ${CPM_STATUS}" >> $log_file 2>&1
  return 0
}

start_server()
{
    case $mode in
            export)
		replace_cpm_script
                if [ $jars_changed = 1  -o $restart_cpm_server -eq 1 ]; then
					cpwd_admin stop -name RFL >> $log_file 2>&1
					cpwd_admin stop -name SMARTVIEW >> $log_file 2>&1
					cpwd_admin stop -name SOLR >> $log_file 2>&1
					if [ ! -z $REPMANDIR ]; then
						cpwd_admin stop -name REPMAN >> $log_file 2>&1
					fi
                    eval $stop_cmd >> $log_file 2>&1
                fi
                eval $start_cmd_export  >> $log_file 2>&1
                ;;
            import)
                eval $start_cmd >> $log_file 2>&1
                 ;;
            migrate_import_domain)
                eval $start_cmd >> $log_file 2>&1
                 ;;
            configure_smc_backup)
                eval $start_cmd >> $log_file 2>&1
                 ;;
            verify)
		replace_cpm_script
                if [ $jars_changed = 1  -o $restart_cpm_server -eq 1 ]; then
					cpwd_admin stop -name RFL >> $log_file 2>&1
					cpwd_admin stop -name SMARTVIEW >> $log_file 2>&1
					cpwd_admin stop -name SOLR >> $log_file 2>&1
                    eval $stop_cmd >> $log_file 2>&1
                fi
                eval $start_cmd >> $log_file 2>&1
                ;;
    esac
	check_cpm_status 1 7200 0
	if [ "$mode" = "export" -o "X$mode" = "Xconfigure_smc_backup" ]; then
	    check_fwm_connected
	fi
}

stop_fwm()
{
    if [ "X$IS_PRIMARY" = "X0" ];then
        eval $stop_fwm_command >> $log_file 2>&1
    fi
}

remove_customer_dirs_in_mds()
{
   if [ ! -z $MDSDIR ]; then
        #remove $MDSDIR/customers/ directories if exist
        if [ -d /var$MDSDIR/customers ];then
            rm -rf /var${MDSDIR}/customers/* 1>/dev/null 2>&1
        fi
    fi
}

remove_sync_temp_dir()
{
	#remove $FWDIR/conf/sync_temp/inspect directories if exist
	if [ -d $FWDIR/conf/synced_tmp/inspect ];then
		echo "About to remove inspect files" >> $log_file 2>&1
		rm -rf $FWDIR/conf/synced_tmp/inspect/* 1>/dev/null 2>&1
		echo "Removed inspect files" >> $log_file 2>&1
	fi
}

run_mininal_postinstall()
{
    # skip mu in multi-site standby machines
    # Run postinstall in multi-site standby machines if the last upgrade on them failed

    #Delete mu finished files if they are left from previous upgrades
    remove_mu_finish_status_files

    #run minimalsetup postintall if set
    if [ $minimal_setup -eq 1 ]; then
        echo "Stopping Check Point services ..." >> $log_file
        update_output "Stopping Check Point services ..."
        eval $stop_cmd >> $log_file 2>&1
        percents=5
        update_output "Preparing server configuration ..."
        remove_customer_dirs_in_mds
        remove_sync_temp_dir
        postgres_start_func
        percents=8
        update_output "Preparing server configuration ..."
        if [ $should_run_apecial_mu -eq 1 ]; then
            cpm_mu_cmd="$MDS_FWDIR/scripts/cpm.sh -s -d -mu -ms -e"
        elif [ $postinstall -eq 1 ]; then
            cpm_mu_cmd=$cpm_cmd  # Run postinstall in multi-site standby machines if the last upgrade on them failed
            echo "Run postinstall in multi-site standby machines if the last upgrade on them failed" >> $log_file 2>&1
        fi
        verify_cpm_is_down 2>>/dev/null
        if [ $? -ne 0 ]; then
            eval $cpm_mu_cmd >> $log_file 2>&1
            let rv=$?
        else
          let rv=1
        fi
        if [ $post_import_failure -eq 0 ];then
            if [ $rv -ne 0 ]; then
                echo "$(date): minimal post install / post install failed" >> $log_file 2>&1
                create_wait_for_task_file="touch $mu_failed_file"
            else
                echo "$(date): minimal post install / post install succeeded" >> $log_file 2>&1
                create_wait_for_task_file="touch $mu_succeeded_file"
            fi
        fi
        eval $stop_cmd >> $log_file 2>&1
        if [ $post_import_failure -eq 1 ]; then
            touch $post_install_after_failure_file >> $log_file 2>&1
        fi
        percents=12
        update_output "Preparing server configuration ..."
        eval $cpm_start_cmd >> $log_file 2>&1
        eval $create_wait_for_task_file
        if [ $post_import_failure -eq 1 ]; then
            rm -f $post_install_after_failure_file >> $log_file 2>&1
            restart_server
        fi
    fi
}

remove_mu_finish_status_files()
{
  if [ -f $mu_failed_file ]; then
    rm $mu_failed_file
    echo -e "$(date): $mu_failed_file exists from previous upgrade! Deleting it.\n" >> $log_file 2>&1
  fi
  if [ -f $mu_succeeded_file ]; then
    rm $mu_succeeded_file
    echo -e "$(date): $mu_succeeded_file exists from previous upgrade! Deleting it.\n" >> $log_file 2>&1
  fi
}
remove_verify_finish_status_files()
{
  if [ -f $verify_failed_file ]; then
    echo -e "$(date): $verify_failed_file exists from previous upgrade! Deleting it.\n" >> $log_file 2>&1
    rm $verify_failed_file
  fi
  if [ -f $verify_succeeded_file ]; then
    echo -e "$(date): $verify_succeeded_file exists from previous upgrade! Deleting it.\n" >> $log_file 2>&1
    rm $verify_succeeded_file
  fi
}

create_java_client_args()
{
  if [ "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Xconfigure_smc_backup" ]; then
    if [ $validations -eq 1 ]; then
      ARGS="-validations"
    fi

    currhostname=`hostname`
    currhostip=`sed 's/\([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\)/\1/g' /etc/hosts | grep $currhostname | awk '{print $1}'`

    if [ "X$server_name" == "X" ] #set default hostname
    then
        server_name=$currhostname
    fi

    if [ "X$domain_server_ip" == "X" ] #set default hostip
    then
        domain_server_ip=$currhostip
    fi

    ARGS="$ARGS -server_name $server_name -domain_server_ip $domain_server_ip"
    if [ "X$MDS_SYSTEM" != "X" ]; then
       ARGS="$ARGS -domain_name $domain_name"
    fi

  fi

  if [ "X$mode" = "Xmigrate_import_domain" ]; then
    ARGS="migrate_import_domain 127.0.0.1 $tarfile $ARGS"
  fi

  if [ "X$mode" = "Xconfigure_smc_backup" ]; then
    ARGS="migrate_import_smc_backup 127.0.0.1 $tarfile $ARGS -cma_name $cma_name -cma_id $cma_id"
  fi

    if [ ! -z "$migrate_args" ]; then
        ARGS="$ARGS -ma $migrate_args"
    fi

    if [ ! -z $outputdir ]; then
        ARGS="$ARGS -d $outputdir"
    fi
    if [ ! -z "$version" ]; then
        ARGS="$ARGS -version $version"
    fi
    if [ "X$mode" = "Xexport" ] || [ "X$mode" == "Xverify" ];then
        if [ "X$nonlocal" = "X1" ]; then
            ARGS="$ARGS -n"
        fi
        if [ ! -z "$revision" ]; then
            ARGS="$ARGS -revision $revision"
        fi
        ARGS="export $ARGS $server_ip $outputfile"
        if [ "X$mode" == "Xverify" ]; then
             ARGS="$ARGS dummy_location -verify"
        fi
        if [ $restart_cpm_server -eq 1 ]; then
             ARGS="$ARGS -restart"
        fi

    elif [ "X$mode" = "Ximport" ];then
        ARGS="import $ARGS $server_ip $tarfile"
    fi

    if [ $ignore_warnings = 1 ]; then
        ARGS="$ARGS -ignore_warnings true"
    fi

    if [  $keep_cloud_sharing -eq 1 ]; then
      if [ "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Ximport" ]; then
        ARGS="$ARGS -keep_cloud_sharing"
      fi
    fi

    if [  $smart_1_cloud -eq 1 ]; then
      ARGS="$ARGS -smart_1_cloud"
    fi

    if [  $verify_all_servers -eq 1 ]; then
      ARGS="$ARGS -verify_all_servers"
    fi

    if [  $skip_tools_check_on_remote -eq 1 ]; then
      ARGS="$ARGS -skip_tools_check_on_remote"
    fi

    if [ $skip_uepm_activation -eq 1 ]; then
      ARGS="$ARGS -skip_uepm_activation"
    fi

}

validate_migrate_args()
{
  echo "$(date) : validating migrate_args - $migrate_args"  >> $log_file 2>&1

    if [ ! -z "$migrate_args" ]; then
        for arg in $(echo $migrate_args | tr "+" "\n")
        do
            case $arg in
              x | -exclude-uepm-postgres-db | -include-uepm-msi-files )
                if [ "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Xconfigure_smc_backup" ]; then
                  echo "The flag '$arg' is not valid for the '$mode' operation."
                  exit 1
                fi
                ;;

              -smart_1_cloud )
                if [ "X$mode" != "Xexport" ]; then
                  echo "'--smart_1_cloud' argument is valid only for the 'export' operation."
                  exit 1
                fi
                ;;
                  
              *)
                if [[ "$arg" =~ ^[[l|x]#.*[0-9]$ ]] && [ "X$mode" != "Xexport" ]; then
                  echo "Providing number of days of logs to export is valid only for the 'export' operation."
                  exit 1
                fi
                ;;
            esac
        done
    fi
}


create_mgmt_api_args()
{
    if [ ! -z "$migrate_args" ]; then
        for arg in $(echo $migrate_args | tr "+" "\n")
        do
            case $arg in
                l)
                    API_ARGS="$API_ARGS include-logs true"
                    ;;
                x)
                    API_ARGS="$API_ARGS include-logs-indexes true"
                    ;;
                -exclude-uepm-postgres-db)
                    API_ARGS="$API_ARGS include-endpoint-database false"
                    ;;
                -include-uepm-msi-files)
                    API_ARGS="$API_ARGS include-endpoint-configuration true"
                    ;;
                -exclude-licenses)
                    API_ARGS="$API_ARGS exclude-licenses true"
                    ;;
                *)
                    remaining_args="$remaining_args -$arg"
                    ;;
            esac
        done
    fi

    if [ $ignore_warnings = 1 ]; then
        API_ARGS="$API_ARGS ignore-warnings true"
    fi

    if [ $keep_cloud_sharing -eq 1 ]; then
      if [ "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Ximport" ]; then
        API_ARGS="$API_ARGS keep-cloud-sharing true"
      fi
    fi

    if [ $smart_1_cloud -eq 1 ]; then
      add_to_additional_args smart-1-cloud true
    fi

    if [ $skip_uepm_activation -eq 1 ]; then
      add_to_additional_args skip-uepm-activation true
    fi

    if [ ! -z "$remaining_args" ]; then
        API_ARGS="$API_ARGS migrate-args \"$remaining_args\""
    fi

    API_ARGS="$API_ARGS file-path $tarfile api-upgrade false"

    if [ "X$additional_json_args" != "X" ]; then
      # add additional_json_args minus last char (,) as additional-json-args
      API_ARGS="$API_ARGS additional-json-args ${additional_json_args%?}"
    fi
}

add_to_additional_args()
{
  param_name=$1
  param_value=$2
  additional_json_args="$additional_json_args$param_name:$param_value,"
}

# called when progress bar should be displayed on the first time
show_first_progress()
{
  if [ $verify_restart_version -eq 1 -o $mode = "configure_smc_backup" ]; then
    return
  fi

  if [ $show_progress_bar -eq 1 ]; then
    clear
  fi

  if [ "$mode" == "export" ]; then
    echo "Exporting the Management Database"
  else
    if [ "$mode" == "import" ]; then
      echo "Importing the Management Database"
    else
      if [ "$mode" == "migrate_import_domain" ]; then
        echo "Running Migrate Import Domain"
      else
        if [ "$mode" == "verify" ]; then
          if [  $verify_all_servers -eq 1 ]; then
            on_all="on all Management Servers"
          fi
          echo "Running Verification Process $on_all"
        fi
      fi
    fi
  fi
  operation_start_time=$(date +"%s")
  echo "Operation started at $(date -d "@$operation_start_time")"
  echo ""
  if [ $show_progress_bar -eq 1 ]; then
    tput sc
    percents=3
	  update_output "Initializing $mode ..."
	  # hide cursor
    tput civis
  fi
}

# called to show fully finished last progress bar
show_last_progress()
{
   if [ $verify_restart_version -eq 1 -o $mode = "configure_smc_backup" ]; then
    return
   fi
   # display cursor
   if [ $show_progress_bar -eq 1 ]; then
    tput cnorm
   fi
   kill_all_child_processes
   percents=100
   update_output "$operation_finished_description"
   echo ""
   echo "Operation finished at $(date)"
}

print_progress_bar_and_description()
{
	percents="$(</dev/shm/percents)"
	bar_size=50
	animations=($(awk 'BEGIN{printf "%c", 45}') $(awk 'BEGIN{printf "%c", 92}') $(awk 'BEGIN{printf "%c", 124}') $(awk 'BEGIN{printf "%c", 47}')) # same as ("-" "\" "|" "/")
	description="$1"
	animation_index=$2
	update_path_index=$3
	progress_bar="["
	for i in $(seq 1 $bar_size);
	do
		if (( $percents >= $(( $i * 100 / $bar_size )) )); then
			progress_bar="${progress_bar}="
		elif (( $percents >= $(( ( $i - 1 ) * 100 / $bar_size )) )); then
			progress_bar="${progress_bar}>"
		else
			progress_bar="${progress_bar} "
		fi
	done
	progress_bar="${progress_bar}]"
	output_line="${progress_bar} "
	if (( $percents < 10 )); then
		output_line="${output_line}  "
	elif (( $percents < 100 )); then
	  output_line="${output_line} "
	fi
	output_line="${output_line}${percents}% ${description}"
	if [ $percents -ne 100 ]; then
	  output_line="${output_line} ${animations[animation_index]}"
	fi
   if [ $update_path_index -eq 0 ]; then
    update_report_path
    tput rc
    tput ed
  else
    tput rc
  fi
	echo "$output_line"
	if [ "$report_path" != "" ] && [[ $description != *"$REPORT_LOG_PATH"* ]]; then
	  if [ $percents -eq 100 ]; then
        echo "Detailed $upgrade_or_migration report is available at $report_path"
    else
        echo "$UpgradeOrMigration progress information is available at $report_path"
    fi
	fi
}

# will be called as new process, prints percents, description and spinner animation to output screen
print_progress_for_state()
{

	animation_index=-1
	update_path_index=0
	old_description=""
	while true;

	do
		description="$(</dev/shm/descriptions)"
		if [ "$description" != "$old_description" ]; then
			animation_index=-1
			update_path_index=0
			old_description=$description
		fi
		animation_index=$(( ( $animation_index + 1 ) % 4 ))
		print_progress_bar_and_description "$description" $animation_index $update_path_index
		if [ "$description" == "$operation_finished_description" ]; then
		  break
		fi
		sleep 0.2
		update_path_index=$(( ( $update_path_index + 1 ) % 50 ))
	done
	tput cnorm
	echo ""
}

# look for the latest report in $MDS_FWDIR/log
update_report_path()
{
  if [ $mode = "verify" ]; then
    return;
  fi

  latest_creation_time=-1
	reports="$(find $MDS_FWDIR/log/ -name 'upgrade_report-*.html')"
  for report in $reports;
  do
    creation_time="$(stat -c %Y $report)"
    if ( (( $latest_creation_time == -1)) || (( $creation_time < $latest_creation_time)) ) && (( $creation_time > $operation_start_time )); then
      report_path=$report
      if [ -f $REPORT_LOG_PATH ]; then
	        report_path=$REPORT_LOG_PATH
	    fi
      latest_creation_time=$creation_time
    fi
  done
}

# display progress bar and description on output console
update_output()
{

  if [ $verify_restart_version -eq 1 -o $mode = "configure_smc_backup" -o $show_progress_bar = 0 ]; then
    return
  fi

  echo $percents >/dev/shm/percents
  echo $1 >/dev/shm/descriptions
  if [ $print_progress_for_state_pid == -1 ]; then
	  print_progress_for_state &
	  print_progress_for_state_pid=$!
  fi
}

# stop updating progress bar
stop_output_update()
{
  if [ $verify_restart_version -eq 1 -o $mode = "configure_smc_backup" ]; then
    return
  fi
  if [ $show_progress_bar -eq 1 ]; then
    tput cnorm
    delete_progress_bar=$1
    if [ $delete_progress_bar -eq 1 ]; then
      tput rc
	    tput ed
    fi
  fi
  kill_all_child_processes
}

# kill progress bar child processes
kill_all_child_processes()
{
  # kill all child processes of poll_task
  kill $(ps -o pid= --ppid $poll_task_pid 2>/dev/null) 1>/dev/null 2>&1

  # kill poll_task, the process that checks the java task's status
  kill $poll_task_pid 1>/dev/null 2>&1
  wait $poll_task_pid 1>/dev/null 2>&1

  # kill the process that updates the progress bar (spinner)

  #kill $print_progress_for_state_pid 1>/dev/null 2>&1
  #wait $print_progress_for_state_pid 1>/dev/null 2>&1
}

poll_task()
{
  if [ $verify_restart_version -eq 1 -o $mode = "configure_smc_backup" -o $show_progress_bar = 0 ]; then
    return
  fi
  while [ 1 ];
  do
    update_output_from_task
    # update the progress bar every 3 seconds
    sleep 3
  done
}

# get most recent task description and percentage and print them to screen
update_output_from_task()
{
  description=$(psql_client cpm postgres -A -t   -c "select comments from tasknotification where  taskid='$taskid'" 2>/dev/null)
  des=$?
  new_percents=$(psql_client cpm postgres -A -t   -c "select progresspercentage  from tasknotification where  taskid='$taskid'" 2>/dev/null)
  per=$?
  status=$(psql_client cpm postgres -A -t   -c "select status  from tasknotification where  taskid='$taskid'" 2>/dev/null)
  st=$?
  if [ $per -eq 0 ] && [ $des -eq 0 ] && [ $st -eq 0 ]; then
    # change percents if $new_percents is not empty and the process is not finished
    # last message ("Done") will be displayed by the main process
    if [ -n "$new_percents" ] && [ -n "$description" ] && [ ! $status -gt 0 ]; then
      if (( $new_percents > $percents )) || [ $new_percents -eq $percents -a "X$description" != "X$prev_description" ]; then
        percents=$new_percents
        prev_description=description
        update_output "$description"
      fi
    fi
  fi
}

wait_for_task()
{
  import_mode=0
  if [ "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Ximport" -o "X$mode" = "Xconfigure_smc_backup" ]; then
    import_mode=1
  fi
    taskId=$1

    sleep 10

    trials=1
    if [ "X$mode" = "Ximport" ]; then
        wait_for_verify_to_finish
        if [ "X$wait_for_postinstall" = "X1" ] || [ "X$IS_PRIMARY" = "X1" ] || [ "X$LOG_SERVER" = "X1" -a "X$IS_MLM" = "X0" ]; then # Primary or SME (SME is log server that is not MLM)
            wait_for_mu_to_finish
         fi
   fi

   if [ "X$mode" = "Xmigrate_import_domain" -o "X$mode" = "Xconfigure_smc_backup" ]; then
     wait_for_mu_to_finish
   fi

    finished=0
    while [ $finished -eq 0 ];
    do
    status=$(psql_client cpm postgres -A -t   -c "select status  from tasknotification where  taskid='$taskid'" 2>/dev/null)
    st=$?
    if [ $st -eq 0 ]; then
        if [ ! -e $MDS_FWDIR/tmp/import_task.id -a ! -e $MDS_FWDIR/tmp/import_last_failed_task.id ] || [ $import_mode -eq 0  ]; then
          if ! [[ $status =~ ^-?[0-9]+$ ]]; then
              print_and_exit "Illegal task status: $status" 1
          fi
        fi

      if [ $task_found_flag -eq 0 ]; then
        task_found_flag=1
      fi
      if [ $status -gt 0 ]; then
         finished=1
      else
        # Verifying CPM server is still up, since if it isn't, than upgrade had failed
         check_cpm_status 4 1800 1
         sleep 3
	  fi
    else # if got here - something bad happened to postgres and we need to fail the task
      should_collect_logs=1
      if [ $task_found_flag -eq 1 ]; then
        echo "$(date) : task found before $mode."  >> $log_file 2>&1
        should_create_migration_failed_files=1
      fi
      print_and_exit "Failed to connect to server. Exiting 5 " 5
	fi

    done
    msg=`/bin/date '+%e%b%Y-%H%M%S'`
    if [ $status -eq 1 ]; then
        echo "$msg: Successfully finished $mode."  >> $log_file 2>&1
        show_last_progress
        if [ "X$mode" = "Xverify" ]; then
          fmsg="$(psql_client cpm postgres -A -t   -c "select comments  from tasknotification where  objid='$taskid'")"
          echo "$(date) : putting task comments  --- $fmsg --- in final_msg"  >> $log_file 2>&1
          final_msg="$fmsg"
        fi
        return 0
    else
        fmsg="$(psql_client cpm postgres -A -t   -c "select comments  from tasknotification where  objid='$taskid'")"
        if [ "X$mode" = "Xverify" ]; then
          show_last_progress
          if [ "X$fmsg" != "X" ]; then
            print_and_exit "$msg: $fmsg" 1
          else
            print_and_exit "$msg: Failed to $mode." 1
          fi
        else
          print_and_exit "$msg: Failed to $mode: $fmsg" 1
        fi
    fi
    return 0
}

wait_for_mu_to_finish()
{
#  trials=1
  while [ $trials -lt 360 ] && [ ! -f $mu_succeeded_file ] && [ ! -f $mu_failed_file ]; #loop for 2 hours
            do
                sleep 20
                let trials=trials+1
            done

  if [ -f $mu_failed_file ]; then
            rm $mu_failed_file
            print_and_exit "Minimal post install / post install failed. Exiting " 1
  else
    if [ -f $mu_succeeded_file ]; then
            rm $mu_succeeded_file
            echo "$(date): Got indication that mu / post install has been completed. Waiting for CPM server to come up ..."  >> $log_file 2>&1
            check_cpm_status 2 1800 0
            echo "$(date): CPM server is up" >> $log_file 2>&1
    else
            should_collect_logs=1
            echo "$(date): Minimal post install did not finish after 2 hours."  >> $log_file 2>&1
            print_and_exit "Minimal post install / post install did not finish after 2 hours. Exiting " 1
    fi
  fi
}

wait_for_verify_to_finish()
{
#  trials=1
    while [ $trials -lt 180 ] && [ ! -f $verify_succeeded_file ] && [ ! -f $verify_failed_file ]  && [ ! -f $mu_succeeded_file ] && [ ! -f $mu_failed_file ]; #loop for 1 hour
              do
                  sleep 20
                  let trials=trials+1
              done

    if [ -f $verify_failed_file ]; then
              rm $verify_failed_file
              print_and_exit "Import verifications failed. Exiting " 1
    else
      if [ -f $verify_succeeded_file ]; then
              rm $verify_succeeded_file
              echo "$(date): Got indication that Import verifications have been completed."  >> $log_file 2>&1
      else
              echo "$(date): Import verifications status was not detected."  >> $log_file 2>&1
      fi
    fi
}

save_phase()
{
    curr_phase=$1
    if [ "X$mode" = "Ximport" ]; then
        echo "$curr_phase" > $phase_file
    fi
}

remove_phase_file()
{
    if [ "X$mode" = "Ximport" ]; then
       \rm -f $phase_file
    fi
}

do_action()
{
	echo "$(date): Running $0" >> $log_file 2>&1

	if [ "X$mode" = "Xmigrate_import_domain" ]; then
	  upgrade_or_migration="migration"
	  UpgradeOrMigration="Migration"
	fi

  if [ "X$mode" = "Xverify" ]; then
    if [ $restart_cpm_server -eq 1 ]; then
	    verify_restart_version=1
	  else
	    verify_new_version=1
	  fi
	fi

	if [ "$mode" == "export" -a $restart_cpm_server -eq 0 ] || [ "$mode" == "import" ] || [ "$mode" == "migrate_import_domain" ] || [ $verify_new_version -eq 1 ]; then
     show_first_progress
	fi

	set_final_message
    case $mode in
            export)
				if [ $restart_cpm_server -eq 1 ]; then
                	cmds=(${export_restart_cmds[*]})
				else
	                cmds=(${export_cmds[*]})
				fi
                first_phase=0
                last_phase=$((${#cmds[@]}-1))
                ;;
            import)
                cmds=(${import_cmds[*]})
                if [ -z $first_phase ]; then
                    first_phase=0
                fi
                if [ -z $last_phase  ]; then
                    last_phase=$(( ${#cmds[@]}-1 ))
                fi
                ;;
            migrate_import_domain)
                cmds=(${migrate_import_domain_cmds[*]})
                first_phase=0
                last_phase=$((${#cmds[@]}-1))
                ;;
            configure_smc_backup)
                cmds=(${configure_smc_backup_cmds[*]})
                first_phase=0
                last_phase=$((${#cmds[@]}-1))
                ;;
            verify)
                if [ $restart_cpm_server -eq 1 ]; then
			        cmds=(${verify_restart_cmds[*]})
		        else
                cmds=(${verify_cmds[*]})
		fi
                first_phase=0
                last_phase=$((${#cmds[@]}-1))
                ;;
            setup)
                cmds=(${major_upgrade_setup_cmds[*]})
                first_phase=0
                last_phase=$((${#cmds[@]}-1))
                ;;
    esac
    for i in ${!cmds[@]}
    do

        if [ $i -ge $first_phase  -a $i -le $last_phase ];then
            echo "$(date): Starting with ${cmds[$i]} command ($i)"  >> $log_file 2>&1
            eval ${cmds[$i]}
            save_phase $i
        fi
        ((i++))
    done


}

run_service()
{
    if [ "X$mode" = "Ximport" ]; then
         should_wait_for_postinstall
         echo "Importing server configuration ..." >> $log_file
         percents=4
         update_output "Importing server configuration ..."
    elif [ "X$mode" = "Xexport" ]; then
      echo "Exporting server configuration ..." >> $log_file
      percents=5
      update_output "Exporting server configuration ..."
    elif [ "X$mode" = "Xverify" ]; then
      echo "Verifying server configuration ..." >> $log_file
      percents=5
      if [ $verify_new_version -eq 1 ]; then
        update_output "Verifying server configuration ..."
      fi
    elif [ "X$mode" = "Xconfigure_smc_backup" ]; then
      echo "Setting up Security Management Backup Server..." | tee -a $log_file
    else
        echo "Running Migrate Import Domain ..." >> $log_file
    fi
    create_java_client_args
    create_mgmt_api_args
    set_java_options_for_client
    remove_mu_finish_status_files
    remove_verify_finish_status_files
    run_migrate_service || print_and_exit "Failed to $mode" 1
}

run_verify_service()
{
    is_slim_mode=$1
	verify_result=0
	verify_cmd=""
	# if upgrade tools were downloaded then take the updated script from there
	if [ -e $NGM_UPGRADE_TOOLS_PATH/scripts/run_puv.sh ]; then
		verify_cmd="$NGM_UPGRADE_TOOLS_PATH/scripts/run_puv.sh"
	# if no upgrade tools - check if the script exist on the take
	elif [ -e $MDS_FWDIR/scripts/run_puv.sh ]; then
		verify_cmd="$MDS_FWDIR/scripts/run_puv.sh"
	fi

	# run verify tool if found
	if [ "$verify_cmd" == "" ]; then
		verify_output="Verification tool doesn't exist, please update the Upgrade Tools."
		verify_result=2
	else
		if [ "X$is_slim_mode" == "X1" ]; then
	        verify_cmd="$verify_cmd -slim_mode"
	    fi
		verify_output="$($verify_cmd)"
		verify_result=$?
	fi

	# check verify result
	notifications="\n\nNotes: \n	1. It is recommended to use the latest upgrade tools package. The latest package is installed automatically on online environments, for upgrade of offline environments refer to sk135172.\n	2. Only latest revision will be upgraded. It is recommended to publish important changes before upgrade. Unpublished changes will be lost.\n	3. Run the upgrade verification on all servers in your environment before you upgrade."
  verify_output+="$notifications"
	if [ $verify_result -ne 0 ]; then
		echo "Verification failed with exit status $verify_result. $verify_output" >> $log_file 2>&1
		collect_debug_logs=0
		print_and_exit "Verification failed: $verify_output" $verify_result $is_slim_mode
	else
		echo -e "Verification Succeeded.\n $verify_output" >> $log_file 2>&1
	fi

	if [ "X$mode" = "Xverify" ]; then
	   final_msg+="$notifications"
  fi

}

run_slim_verify_service()
{
	if [ "X$mode" = "Ximport" -a "X$UPGRADE_CONTEXT" = "Xcpuse" ]; then
		return
	fi
    run_verify_service '1'
}

run_migrate_service()
{
    if [ "X$mode" = "Xexport" ];then
        echo "Exporting data from $server_ip Management Server file to $outputfile ..."   >> $log_file 2>&1
    elif [ "X$mode" = "Xverify" ];then
        echo "Verifying data from $server_ip Management Server" >> $log_file 2>&1
    else
        echo "Importing data from file $tarfile to $server_ip Management Server..."   >> $log_file 2>&1
    fi

    if ! api_login || [ "X$mode" = "Xexport" ] || [ ! -z $outputdir ] || [ "X$mode" == "Ximport" -a "X$IS_PRIMARY" = "X0" ] || [ "X$mode" = "Xconfigure_smc_backup" ] || [ "X$mode" = "Xverify" ] || [ ! -z "$previous_upgrade_failed" ];then
        if [[ -n "$NGM_UPGRADE_TOOLS_JARS_PATH" ]]; then
            NGM_CLASSPATH_OPT="-cp $NGM_UPGRADE_TOOLS_JARS_PATH/*:$CPM_DIR/*"
        else
            NGM_CLASSPATH_OPT="-cp $CPM_DIR/*:/home/admin/*"
        fi


        if [ -f $log4j2_conf_file ]; then
          if [ "X$LOG4J_OVERRIDE" = "X" ]; then
            NGM_CLASSPATH_OPT="-Dlog4j2.configurationFile=$log4j2_conf_file $NGM_CLASSPATH_OPT"
          else
            NGM_CLASSPATH_OPT="-Dlog4j2.configurationFile=$LOG4J_OVERRIDE $NGM_CLASSPATH_OPT"
          fi
        fi

        echo "$(date): Calling UpgradeClient.java with args: $ARGS"  >> $log_file 2>&1
        taskid=$($JAVA_HOME/bin/java $NGM_JAVA_OPTS -Dfile.encoding="UTF-8" $NGM_CLASSPATH_OPT "com.checkpoint.management.upgrade.UpgradeClient" $ARGS 2>/dev/null)
        stat=$?
        if [ $stat -ne 0 ]; then
            stop_output_update 1
            echo "Failed to $mode. Check if upgrade_web_client.jar is compatible. See $client_log or $server_log for more details" | tee -a $log_file
            return $stat
        fi
    else
        echo "$(date): Calling import-management API with args: $API_ARGS --port $portNumber"  >> $log_file 2>&1
        api_command="mgmt_cli -d \"System Data\" -r true import-management $API_ARGS --port $portNumber"
        eval $api_command >> $client_log 2>&1
        taskid=$(grep "task-id:" $client_log | tail -1 | awk -F'"' '{print $2}')
        if [ "X$taskid" = "X" ]; then
            echo "Failed to $mode. See $client_log or $server_log for more details" | tee -a $log_file
            return 1
        fi
    fi

    poll_task &
    poll_task_pid=$!

# TODO: should we remove it
    if [ "X$async" = "X1" ]; then
         echo "TaskId = $taskid" >> $log_file  2>&1
         echo "$taskid"
    else
        wait_for_task $taskid
    fi

    return 0
}

api_login()
{
  my_ret=1
  command_file=/tmp/cmd.${uniq_ext}.txt

  mgmt_cli -r true --port $portNumber login > $command_file 2>&1
  mgmt_cli -r true --port $portNumber logout -s $command_file >> $log_file 2>&1

  if [ $? -eq 0 ]; then
      my_ret=0
  fi

  echo "$(date) API login return value is : $my_ret" >> $log_file  2>&1
  return $my_ret
}

stop_server()
{
 if [ "X$mode" = "Ximport" ]; then
    unset NGM_JAVA_OPTS
    eval $stop_cmd >> $log_file 2>&1
 fi
}

restart_server()
{
  unset NGM_JAVA_OPTS
  if (( $exit_code != 0 )); then
   stop_output_update 1
   echo "${mode} failed."
  else
   show_last_progress
    if [ $restart_cpm_server -eq 1 -a $mode = "export" ] || [ $restart_cpm_server -eq 1 -a $mode = "verify" ]; then
      echo "Stopping Check Point Services ..."
    fi
  fi
  cpwd_admin stop -name RFL >> $log_file 2>&1
  cpwd_admin stop -name SMARTVIEW >> $log_file 2>&1
  cpwd_admin stop -name SOLR >> $log_file 2>&1
  if [ ! -z $REPMANDIR ]; then
	cpwd_admin stop -name REPMAN >> $log_file 2>&1
  fi
  eval $stop_cmd >> $log_file 2>&1
	if [ "X$MDSDIR" != "X" -a "$mode" = "import" ]; then
		# propagate mds SIC to all CMAs
		$MDSDIR/bin/set_mds_info -b -y >> $log_file 2>&1
	fi
	move_back_cpm_script
	unset NGM_UPGRADE_TOOLS_PATH
	unset NGM_UPGRADE_TOOLS_JARS_PATH
	if [ $exit_code -eq 0 -o $mode = "export" ] || [ $exit_code -eq 0 -o $mode = "verify" ]; then
		get_start_permission
	fi
	if [ $? -eq 0 ]; then
		eval $start_cmd >> $log_file 2>&1
	fi

}

unset_upgrate_tools_path()
{
	unset NGM_UPGRADE_TOOLS_PATH
	unset NGM_UPGRADE_TOOLS_JARS_PATH
}

replace_cpm_script()
{
 if [[ -n "$NGM_UPGRADE_TOOLS_PATH" ]]; then
    if [ -e $NGM_UPGRADE_TOOLS_PATH/scripts/cpm.sh ]; then
        cp $MDS_FWDIR/scripts/cpm.sh $MDS_FWDIR/scripts/cpm.sh.backup
        cp $NGM_UPGRADE_TOOLS_PATH/scripts/cpm.sh $MDS_FWDIR/scripts/cpm.sh
    fi
 fi

}

move_back_cpm_script()
{
 if [[ -n "$NGM_UPGRADE_TOOLS_PATH" ]]; then
    if [ -e $MDS_FWDIR/scripts/cpm.sh.backup ]; then
        cp $MDS_FWDIR/scripts/cpm.sh.backup $MDS_FWDIR/scripts/cpm.sh
    fi
 fi
}

print_error()
{
   message="$1"
   stop_output_update 1
   if [ $show_progress_bar -eq 1 ]; then
    # display cursor
    tput cnorm
   fi
   echo -e $message | tee -a $log_file
   update_report_path
   if [ "$report_path" != "" ] && [[ $message != *"$REPORT_LOG_PATH"* ]]; then
    echo "Detailed upgrade report is available at $report_path"
   fi
   echo ""
   echo "Operation finished at $(date)"
}

print_and_exit()
{
  echo "$(date) print_and_exit" >> $log_file 2>&1
 message=$1
 exit_code=$2
 slim_mode=$3
 if [ $exit_code -ne 0  -a "$mode" = "import" ]; then
    remove_phase_file
 fi
 if [ $restart_cpm_server -eq 1 -a $exit_code -ne 0  -a "$mode" != "verify" ]; then
	if [ "$mode" != "export" -o $verify_result -eq 0 ]; then
		restart_server
	fi
 fi
 revert_jars
 kill_progress_bar >& /dev/null
 if [ "$mode" == "import" ]; then
   check_migration_files_creation
 fi
 if [ "$mode" == "export" ] || [ "$mode" == "import" ] || [ "$mode" == "migrate_import_domain" ] || [ "X$slim_mode" == "X1" ]; then
    if (( $exit_code != 0 )); then
       print_error "$message"
    else
      echo -e "$message" | tee -a $log_file
    fi
    collect_logs
 else
    echo -e "$message" | tee -a $log_file
 fi
 #copy_cpdiag_data

 if [ $show_progress_bar = 1 ]; then
	 rm -f /dev/shm/percents
	 rm -f /dev/shm/descriptions
 fi

 if [ $mask_info -eq 1 ]; then
    rm -rf $TEMP_EXPORT_DIR
 fi

 if [ "X$mode" == "Xexport" ] || [ "X$mode" == "Ximport" ]; then
  rm -f $debug_logs_location_file 1>/dev/null 2>&1
 fi
 stop_output_update 0
 exit $exit_code

}

copy_cpdiag_data()
{
     #move /upgrade_stats.xml - xml file with data for CpDaig- to /var/log
    echo "upgrade_stats.xml $(date)" >> $log_file 2>&1
    if [ -e /.$MDS_FWDIR/cpdiag/upgrade_stats.xml ]; then
      echo "upgrade_stats.xml exists $(date)" >> $log_file 2>&1
      if [ -e /var/log/upgrade_stats.xml ]; then
        echo "upgrade_stats.xml existed in var/log $(date)" >> $log_file 2>&1
        cat /.$MDS_FWDIR/cpdiag/upgrade_stats.xml >> /var/log/upgrade_stats.xml
        rm /.$MDS_FWDIR/cpdiag/upgrade_stats.xml
      else
        echo "upgrade_stats.xml didn't exist in var/log $(date)" >> $log_file 2>&1
        mv /.$MDS_FWDIR/cpdiag/upgrade_stats.xml /var/log >> $log_file 2>&1
      fi
    fi
}

get_answer()
{
	answer=""
    msg=("$@")
	if [ $non_interactive -eq 1 ]; then
		answer="y"
		return 0
	fi
	clean_input
    while [ 1 ]
      do
      echo -n "$msg"
      read REP
      for OPT in y Y n N yes YES no NO
        do
        if [ "X$OPT" = "X$REP" -o "X$REP" = "X" ]
            then
            answer=$REP
            break 2
        fi
      done
      echo "Invalid input. Expected [y/n]."
    done
    return 0
}

clean_input()
{
	while read -t 0 notused; do
		read input
		# in case script was used with infinite stdin stream ( for example: "yes | migrate_server..." )
		# we should skip the input cleanup
        if [ "X$input" = "Xy" -o "X$input" = "Xyes" -o "X$input" = "XY" -o "X$input" = "XYES" ]; then
            break
        fi
	done

}

get_stop_permission()
{
	stop_message="The $mode operation will eventually stop all Check Point services ($stop_cmd). Do you want to continue (yes/no) [n]? "
	get_answer "$stop_message"
	if [ "X$answer" = "X" ]; then
		answer="n"
	fi
	if [ "$answer" = "n" -o "$answer" = "no" -o "$answer" = "N" -o "$answer" = "NO" ]; then
		echo "Aborting $mode ..." | tee -a $log_file
		exit 1
	fi

	# start showing progress bar when restart is needed
  show_first_progress
}

get_start_permission()
{
  # display cursor
  if [ $show_progress_bar -eq 1 ]; then
    tput cnorm
  fi
	start_message="The $mode operation completed"
	if [ $exit_code -eq 0 ]; then
		start_message="$start_message successfully"
	else
		start_message="$start_message with errors"
	fi
	start_message="$start_message. Do you wish to start Check Point services (yes/no) [y]? "

	#Limiting the waiting for the progress bar to done printing before continuing.
	kill_progress_bar >& /dev/null

	get_answer "$start_message"
	if [ "X$answer" = "X" ]; then
		answer="y"
	fi
	if [ "$answer" = "n" -o "$answer" = "no" -o "$answer" = "N" -o "$answer" = "NO" ]; then
		return 1
	else
		echo "Starting Check Point services ..." | tee -a $log_file
		return 0
	fi
}

kill_progress_bar()
{
	if [ $show_progress_bar -eq 1 ]; then
		times=1
		while [ $times -le 60 ]
		do
			ps -p $print_progress_for_state_pid >& /dev/null;
			if [ $? -eq 0 ]; then
				sleep 1
				times=$(( $times + 1 ))
			else
				break
			fi
		done

		ps -p $print_progress_for_state_pid >& /dev/null;
		if [ $? -eq 0 ]; then
			kill $print_progress_for_state_pid
			clear
		fi
	fi
}

check_primary_upgrade()
{
    # notifing the user to to check that the upgrade of primary finished when upgrading secondary
   if [ $IS_PRIMARY -eq 0 ]; then
       check="Before you import a $machine_type, you must first upgrade the primary machine and make sure it is up and running. Do you want to continue (yes/no) [y] ? "
	     get_answer "$check"
	     echo "$answer"
	     if [ "X$answer" = "X" ]; then
		       answer="y"
	     fi
	     if [ "$answer" = "n" -o "$answer" = "no" -o "$answer" = "N" -o "$answer" = "NO" ]; then
		       echo "Aborting $mode ..." | tee -a $log_file
		       exit 1
       fi

    fi
}


add_migrate_arg()
{
    curr_arg=$1
    migrate_args="${migrate_args}${curr_arg:1}+"
}

check_migration_type()
{
    if [ "$is_old_migrate" == "0" ];then
		return
	fi

    if [ "X$UPGRADE_CONTEXT" = "Xcpuse" ]; then
        migration_type=$(cat $outputdir/extra_data/UpgradeMachineStateData.data | jq -r '.[].migrationType' | tr -d [] | sed '/^$/d')

        cat $outputdir/extra_data/UpgradeMachineStateData.data | grep UpgradeDomainStateSmc >& /dev/null
        is_source_mds=$?
    else
        migration_type=$(tar -axf $tarfile ./extra_data/UpgradeMachineStateData.data -O | jq -r '.[].migrationType' | tr -d [] | sed '/^$/d')

        tar -axf $tarfile ./extra_data/UpgradeMachineStateData.data -O | grep UpgradeDomainStateSmc >& /dev/null
        is_source_mds=$?
    fi

    if [ "$migration_type" = "null" -o "X$migration_type" = "X" ]; then
        return
    fi

    is_valid_case=0

    if [ $is_source_mds = 1 ]; then
        if [ "X" = "X$MDSDIR" ]; then
            if [ "$migration_type" = "Migration" -a "X$mode" = "Xmigrate_import_domain" ]; then
                # MDS to SMC with migration export file.
                is_valid_case=1
            fi
        else
            if [ "$migration_type" = "Full" -a "X$mode" = "Ximport" ]; then
                # MDS to MDS with full export file.
                is_valid_case=1
            fi
        fi
    else
        if [ "X" = "X$MDSDIR" -a  "$migration_type" = "Full" -a "X$mode" = "Ximport" ]; then
            # SMC to SMC with full export file.
            is_valid_case=1
        fi
    fi

    if [ $is_valid_case = 0 ]; then

        source_type="SMC"
        machine_type="MDS"

        if [ $is_source_mds = 1 ]; then
            source_type="MDS"
        fi

        if [ "X" = "X$MDSDIR" ]; then
            machine_type="SMC"
        fi

        echo "Got $migration_type export file from $source_type to $machine_type in mode $mode" >> $log_file 2>&1
        print_and_exit "Failed to run migrate_server $mode. Please verify that you use the correct export file and the correct command (import/migrate_import_domain)." 1
    fi
}

check_old_migrate()
{
    tar -axf $tarfile ./configuration2 -O >& /dev/null
    is_old_migrate=$?
}

set_final_message()
{
  echo "$(date) : set_final_message"  >> $log_file 2>&1
 final_msg="The $mode operation finished successfully."
 if [ "$mode" = "export" ]; then
	final_msg="$final_msg \nExported data to"
	if [ ! -z $outputfile ]; then
        final_msg="$final_msg: $outputfile."
	elif [ ! -z $outputdir ]; then
	    final_msg="$final_msg: $outputdir."
	fi
 fi
}

collect_logs()
{
  if [ $collect_debug_logs -eq 1 ]; then
    if [ $should_collect_logs -eq 1 -o "X$fmsg" = "X$interrupted_task_comment" ]; then
      call_logs_collection
      echo "$(date) : fmsg: $fmsg , should_collect_logs: $should_collect_logs" >> $log_file 2>&1
    fi
  fi
}

check_migration_files_creation()
{
  if [ $should_create_migration_failed_files -eq 1 ] || [[ $fmsg == *"$interrupted_task_comment"* ]]; then
      create_migration_had_failed_file
      eval $stop_fwm_command >> $log_file 2>&1
      echo "$(date) : fmsg: $fmsg , should_create_migration_failed_files: $should_create_migration_failed_files" >> $log_file 2>&1
    fi
}

call_logs_collection()
{
  upgrade_tools_path="/opt/CPupgrade-tools-$version"
  debug_logs_location="/var/log/upgrade-$mode.collected_from_script.${uniq_ext}.tgz"
  if [ -x $upgrade_tools_path/scripts/collect_upgrade_log_files.sh ]; then
        echo "$(date) : Collecting debug logs..." >> $log_file 2>&1
        $upgrade_tools_path/scripts/collect_upgrade_log_files.sh $debug_logs_location $exit_code
    else
        echo "Did not find collect_upgrade_log_files script in $upgrade_tools_path" >> $log_file 2>&1
        if [ -x $MDS_FWDIR/scripts/collect_upgrade_log_files.sh ]; then
          echo "$(date) : Collecting upgrade debug logs..." >> $log_file 2>&1
          $MDS_FWDIR/scripts/collect_upgrade_log_files.sh $debug_logs_location $exit_code
    fi

  fi
}

should_wait_for_postinstall()
{
  echo "checking postinstall $previous_upgrade_failed,  $IS_MLM,   $IS_PRIMARY,  $LOG_SERVER  " >> $log_file 2>&1
    if [ "X$IS_MLM" = "X1" -o "X$IS_PRIMARY" = "X0" ]; then
        if [ "X$LOG_SERVER" = "X0" ]; then
          if [ ! -z "$previous_upgrade_failed" ]; then
            echo "Run postinstall in multi-site standby machines if the last upgrade on them failed" >> $log_file 2>&1
            wait_for_postinstall=1
          fi
    	fi
    fi
}

find_current_version()
{
 ver=`$CPDIR/bin/cpprod_util CPPROD_GetVerText CPshared|sed "s/ //g"`
 releaseVer=`$CPDIR/bin/cpprod_util CPPROD_GetValue FW1 CurrentMgmtReleaseVersion 1 2>/dev/null`
 if [ $? -eq 0 ]; then
    if [ "X$releaseVer" = "XGA" ]; then
        echo $ver
    else
        echo "${ver}.${releaseVer}"
    fi
 else
	if [ "X$ver" = "XR80.20" ]; then
		echo "${ver}.M1"
	else
	    echo $ver  #not sure this is correct if we could not find  CurrentMgmtReleaseVersion value in registry
	fi
 fi
}

check_previous_upgrade_had_failed()
{
  echo "$(date) : Running check if previous upgrade had failed. ">> $log_file 2>&1
  postgres_start_func

  previous_upgrade_failed=$(psql_client cpm postgres -A -t   -c "select status from (select status from tasknotification where displayname='Configuration import' order by starttime desc limit 1) F  where status='4';" 2>/dev/null)
  if [ $? -ne 0 ]; then
      echo "Could not run compatibility check. Please verify all server processes are up. If you require assistance, contact Check Point Support."
      exit 2
  fi

}

remove_migration_had_failed_file()
{
	# If last upgrade failed, we need to clean the migration_had_failed and migration_in_progress files
	#if [ ! -z "$previous_upgrade_failed" ]; then
	    if [ "X$MDSDIR" = "X" ]; then
		if [ -f $MIGRATION_HAD_FAILED_FILE ]; then
                    rm $MIGRATION_HAD_FAILED_FILE
                fi
            else
                if [ -f $MIGRATION_HAD_FAILED_FILE ]; then
                    rm $MIGRATION_HAD_FAILED_FILE
                fi
                if [ -f $MIGRATION_IN_PROGRESS_FILE ]; then
                    rm $MIGRATION_IN_PROGRESS_FILE
                fi
            fi
	#fi

}

create_migration_had_failed_file()
{
	# If upgrade failed, create the migration_had_failed and migration_in_progress files
	if [ "X$MDSDIR" = "X" ]; then
		 if [ ! -f $MIGRATION_HAD_FAILED_FILE ]; then
         touch $MIGRATION_HAD_FAILED_FILE
         echo "$(date) : Creating new file : $MIGRATION_HAD_FAILED_FILE" >> $log_file 2>&1
     fi

  else
     if [ ! -f $MIGRATION_HAD_FAILED_FILE ]; then
         touch $MIGRATION_HAD_FAILED_FILE
         echo "$(date) : Creating new file : $MIGRATION_HAD_FAILED_FILE" >> $log_file 2>&1
     fi
     if [ ! -f $MIGRATION_IN_PROGRESS_FILE ]; then
         touch $MIGRATION_IN_PROGRESS_FILE
         echo "$(date) : Creating new file : $MIGRATION_IN_PROGRESS_FILE" >> $log_file 2>&1
     fi
  fi
}

disable_progress_bar()
{
	show_progress_bar=0
}


is_equal_versions()
{
  upgrade_tools_path="/opt/CPupgrade-tools-$version"
  old_migrate_path="$upgrade_tools_path/bin/migrate"

  if [ $clm_logs -eq 1 ]; then
    if [ "X$mode" = "Xexport" ];then
      echo "clm_logs flag is on -> running legacy migrate tool" >> $log_file
      run_old_migrate_clm_logs
    elif [ "X$mode" = "Ximport" ];then
      file_path="$(tar ztvf $tarfile | grep ./configuration2 )"
      if [ ! -z "$file_path" ]; then
        echo "clm_logs flag is on -> running legacy migrate tool" >> $log_file
        run_old_migrate_clm_logs
      else
        print_and_exit "Incorrect tgz file." 1
      fi
    fi
  fi

  if [ "X$UPGRADE_CONTEXT" = "Xcpuse" -o "X" != "X$MDSDIR" -o "$force_upgrade_flow" = "0" ]; then
	return
  fi

  if [ "X$mode" = "Xexport" ];then
    if [ "$version" == "$ver" ];then
        echo "Source and target versions are equals -> running old migrate" > $log_file
        run_old_migrate
    else
        return
    fi
  elif [ "X$mode" = "Ximport" ];then
    if [ "$is_old_migrate" == "0" ];then
        source_version=$(tar -axf $tarfile ./configuration2 -O | grep :mgmt_release_version | cut -d " " -f 9)
        if [ "$source_version" == "$ver" ];then
            echo "Source and target versions are equals and export done with old migrate -> running old migrate" > $log_file
            run_old_migrate
        fi
    fi
    return
  fi
}

is_valid_export() {
  if [ "X$mode" = "Xexport" ];then

    src=$(find_current_version)
    dst=$version

    if [ "X$src" = "X$dst" ]; then
      echo "Export to same version - $src - permitted." >> $log_file
      return
    fi

    echo "Comparing $src to $dst" >> $log_file

    # Remove R
    src=$(echo $src | tr -d 'R')
    dst=$(echo $dst | tr -d 'R')

    # Check if src and dst start with 80.20
    if [[ $src == 80.20.M* && $dst == 80.20.M* ]]; then
      # Get M versions.
      src_mver=$(echo $src | awk -F '.' '{print $3}' | tr -d 'M')
      dst_mver=$(echo $dst | awk -F '.' '{print $3}' | tr -d 'M')

      if [[ $dst_mver -lt $src_mver ]]; then
        echo "Attempted export to lower version - stopping export." >> $log_file
        print_and_exit "Target version cannot be lower than source version." 1
      fi
    fi

    echo "Comparing $src to $dst" >> $log_file

    # src or dst are R80.20.MX, we ignore the M (as it was already checked.)
    if [[ $src == 80.20.M* ]]; then
      src=$(echo $src | awk -F '.' '{print $1"."$2}')
    fi
    if [[ $dst == 80.20.M* ]]; then
      dst=$(echo $dst | awk -F '.' '{print $1"."$2}')
    fi

    # Compare versions, need to use bc because bash doens't support floating point arithmatics.
    cmp_result=$(echo "$dst < $src" | bc -l)
    if [[ $cmp_result -eq 1 ]]; then
      echo "Attempted export to lower version - stopping export." >> $log_file
      print_and_exit "Target version cannot be lower than source version." 1
    fi
    return
  fi
}

run_old_migrate()
{
  # because the verification called from the task, and here we are not getting into the task
  run_verify_service
  kill $print_progress_for_state_pid >& /dev/null
  kill_progress_bar
  if [ $show_progress_bar -eq 1 ]; then
    clear
  fi
  if [ "X$migrate_args" != "X" ]; then
      old_migrate_args="-$( echo "$migrate_args" | sed -r 's/[+]+/ -/g' | sed 's/ -$//' | sed 's/#/ /g')"
  fi
  if [ $non_interactive -eq 1 ]; then
    old_migrate_args="$old_migrate_args -n "
  fi
  if [ $mask_info -eq 1 ]; then
    old_migrate_args+=" -f"
  fi
  if [ $keep_cloud_sharing -eq 1 ]; then
    if [ "X$mode" = "Ximport" ]; then
      old_migrate_args="$old_migrate_args --keep_cloud_sharing"
    fi
  fi
  old_migrate_path="$old_migrate_path $mode $old_migrate_args $tarfile"
  unset_upgrate_tools_path
  echo "old_migrate_path: $old_migrate_path" >> $log_file
  $old_migrate_path
  res=$?
  if [ $res -eq 0 ]; then
    set_final_message
  else
    final_msg="Failed to $mode."
  fi
  print_and_exit "$final_msg" $res
}

run_old_migrate_clm_logs()
{
  echo "MDS_INTERNAL_CMD_ALLOWED: "$MDS_INTERNAL_CMD_ALLOWED"" >> $log_file
  user_configure=0

  # because the verification called from the task, and here we are not getting into the task
  run_verify_service
  kill $print_progress_for_state_pid >& /dev/null
  kill_progress_bar
  if [ $show_progress_bar -eq 1 ]; then
    clear
  fi
  if [ "X$migrate_args" != "X" ]; then
    old_migrate_args="-$( echo "$migrate_args" | sed -r 's/[+]+/ -/g' )"
  fi
  if [ $non_interactive -eq 1 ]; then
    old_migrate_args="$old_migrate_args -n "
  fi
  if [ $mask_info -eq 1 ]; then
    old_migrate_args+=" -f"
  fi
  if [ $clm_logs -eq 1 ]; then
    old_migrate_args+=" --config_only"
    old_migrate_args+=" -x"
		mdsenv $clm_name
		echo "run mdsenv $clm_name" >> $log_file

    if [ "X$mode" = "Xexport" ]; then
      old_migrate_path="$old_migrate_path $mode $old_migrate_args $tarfile"
      echo "old_migrate_path: $old_migrate_path" >> $log_file
    elif [ "X$mode" = "Ximport" ]; then
      old_migrate_args+=" -m"
      old_migrate_path="$old_migrate_path $mode $old_migrate_args $tarfile"
      echo "old_migrate_path: $old_migrate_path" >> $log_file

      # configure MDS_INTERNAL_CMD_ALLOWED if does not exist
      if [ -z "$MDS_INTERNAL_CMD_ALLOWED" ]; then
          export MDS_INTERNAL_CMD_ALLOWED=1
          echo "Change MDS_INTERNAL_CMD_ALLOWED: "$MDS_INTERNAL_CMD_ALLOWED"" >> $log_file
        else
          user_configure=1
      fi
    fi
  fi

  unset_upgrate_tools_path
  $old_migrate_path
  res=$?
  mdsenv
  if [ $user_configure -eq 0 ]; then
      unset MDS_INTERNAL_CMD_ALLOWED
  fi
  if [ $res -eq 0 ]; then
    set_final_message
  else
    final_msg="Failed to $mode."
  fi
  print_and_exit "$final_msg" $res
}

check_postgres_is_up()
{
	MAX_TRIALS=20
	Sleep_time=30
	trials=0
	ret=1
	echo "Checking if postgres is up" >> $client_log
	while [ $trials != $MAX_TRIALS ]
	do
		((trials++))
		STATUS_OUTPUT="$(su -s /bin/bash -c "$MDS_FWDIR/scripts/postgres_commands.sh status" cp_postgres)" >> $log_file 2> /dev/null
		if [ $? -eq 0 ]; then
		  echo "Done with ${trials} trials - postgres is up! message: ${STATUS_OUTPUT}" >> $log_file
		  echo "postgres is up" >> $client_log
		  ret=0
		  break;
		fi
		echo "Trial number ${trials}: has failed with error: ${STATUS_OUTPUT} - Trying again" >> $log_file
		sleep $Sleep_time
	done
	if [ $ret -eq 1 ]; then
    if [ $minimal_setup -eq 1 ]; then
      return 1
    fi
		time_spent=$((${trials}*${Sleep_time}/60))
		echo "postgres is still down (after $time_spent [min]) - exiting" >> $client_log
	    print_and_exit "postgres is still down (after $time_spent [min]) - exiting" 1
	fi
  return 0
}

postgres_start_func()
{
  local POSTGRES_WAS_DOWN=0
  local POSTGRES_STATUS=3
  check_postgres_status POSTGRES_STATUS

  if [ $POSTGRES_STATUS -ne 0 ]; then
	POSTGRES_WAS_DOWN=1
  fi
  if [ $POSTGRES_WAS_DOWN -eq 1 ];then
	  echo "==================================================FWDIR=$MDS_FWDIR $MDS_FWDIR/scripts/postgres_start.sh" >> $log_file 2>&1
	  eval $postgres_start >> $log_file 2>&1
	  POSTGRES_STATUS=3
	  busy_wait_check_postgres_status POSTGRES_STATUS
	  cd $WORK_DIR
	  if [ $POSTGRES_STATUS -ne 0 ]; then
		  echo "Failed to start. For more information, see $log_file."
		  exit 2
	  fi
  fi

}

check_postgres_status()
{
  local MAX_TRIES=3
	local RET=1
	local RETURN_VAL=$1
  PREV_LOCATION=`pwd`
	cd $PGDIR

	if [ -f /var/tmp/postgres_max_tries ];then
		MAX_TRIES=`$CAT /var/tmp/postgres_max_tries`
	fi

	su -s /bin/bash -c "FWDIR=$MDS_FWDIR $MDS_FWDIR/scripts/postgres_commands.sh status" cp_postgres >> $log_file 2>&1
	RET=$?

	if [ $RET -eq 0 ];then
	  echo "waiting for postgres to accept connections" >> $log_file 2>&1
		RET=3
		TRIES=0
		while [ $RET -ne 0 -a $TRIES -lt $MAX_TRIES ]
		do
		  $MDS_FWDIR/bin/psql_client -U postgres cpm -c "select 1;" >> $log_file 2>&1
			RET=$?
			sleep 1
			let TRIES=TRIES+1
		done
	fi

  echo "check_postgres_status end. return value is $RET" >> $log_file 2>&1
  cd $PREV_LOCATION
	eval $RETURN_VAL="'$RET'"
}


busy_wait_check_postgres_status()
{
  local MAX_TRIES=60
	local RETURN_VAL=$1
	cd $PGDIR
	TRIES=0
	local POSTGRES_STATUS_RET=1
	local QUERY_RET=1
	if [ -f /var/tmp/postgres_max_tries ];then
		MAX_TRIES=`$CAT /var/tmp/postgres_max_tries`
	fi
	while [ $POSTGRES_STATUS_RET -ne 0 -a $TRIES -lt $MAX_TRIES ]
	do
		check_postgres_status POSTGRES_STATUS_RET
		sleep 1
		let TRIES=TRIES+1
	done
	TRIES=0
	if [ $POSTGRES_STATUS_RET -eq 0 ];then
		TRIES=0
		while [ $QUERY_RET -ne 0 -a $TRIES -lt $MAX_TRIES ]
		do
			echo "==================================================$MDS_FWDIR/bin/psql_client -U postgres cpm -c select 1" >> $log_file 2>&1
			$MDS_FWDIR/bin/psql_client -U postgres cpm -c "select 1;" >> $log_file 2>&1
			QUERY_RET=$?
			sleep 1
			let TRIES=TRIES+1
		done
	else
		echo "Could not run compatibility check. Please verify all server processes are up. If you require assistance, contact Check Point Support." >> $log_file 2>&1
	fi
	eval $RETURN_VAL="'$QUERY_RET'"
}

#############################################################################################
trap signal_2 2
trap signal_3 3
trap signal_9 9
trap signal_15 15

set_vars
parse_args $@
validate_args || exit 1
check_current_status
prepare_jars
do_action
print_and_exit "$final_msg" 0
